#include <stdio.h>
#include <signal.h>
#define  MAX  5

int cnt = 0, totcnt = 0, interrupts = 0; 
void print(void);

int main(void)
  {
    /* catch the interactive attention signal */
    (void) signal(SIGINT, print);

    for ( ; getchar(); cnt++)
        ;
    printf("\ntotal characters read = %d\n", totcnt);

    return 0;
  }

void print(void)
  {
    if (interrupts++ < MAX)
        /* reset to catch the interactive attention signal */
        (void) signal(SIGINT, print);

    printf("\ncharacters read = %d\n", cnt);
    totcnt += cnt;
    cnt = 0;
  }
