#include <stdio.h>

int main(void)
{
int nchars;
long lg;
float f;
char *s = "snare";

printf("%g %G %G %g\n",
        999999.0, 1000000.0, .0001, .00001);

printf("\n");
printf("%g %g %g %g %g\n",
        2/2.0, 2/3.0, 2/4.0, 4/3.0, 0);

printf("\n");
printf("{%d} {%.2d} {%.0d} {%.d}\n", 0, 0, 0, 0);
printf("{%d} {%3d} {%-3d} {%03d} {%3.2d} {%3.0d}\n",
        0, 0, 0, 0, 0, 0);


printf("\n");
printf("{%4s}   {%-4s}   {%.4s}   {%-.4s}\n",
        s, s, s, s);
printf("{%6s}  {%-6s}  {%.6s}  {%-.6s}\n",
        s, s, s, s);
printf("{%6.4s}  {%-6.4s}  {%4.6s}  {%-4.6s}\n",
        s, s, s, s);

printf("\n");
printf("{%4.0f} %.1f %.2f %.5f\n",
        1/3.0, 1/3.0, 1/3.0, 1/3.0, 1/3.0);
printf("{%4.0e} %.1e %.2e %.5e\n",
        1/3.0, 1/3.0, 1/3.0, 1/3.0, 1/3.0);
printf("{%4.0g} %.1g %.2g %.5g\n",
        1/3.0, 1/3.0, 1/3.0, 1/3.0, 1/3.0);

printf("\n");
for (f = 1; f >= -1; f--)
    printf("% E  %+e  %E\n", f, f, f);

printf("\n");
for (lg = 0;  lg <= 10; lg += 10)
    printf("0%lo %#lo 0X%lX %#lX\n", lg, lg, lg, lg);

printf("\n");
printf("%f %.0f %#.0f %g %#g\n",
        1.0, 1.0, 1.0, 1.0, 1.0);

printf("\n");
printf("%06.1f %0*.*f\n", -1.55, 6, 0, -1.55);

printf("\n");
printf("%%n has been added by ANSI C\n%n", &nchars);

return 0;
}
