#include "def.h"

/* externals global to this module */
static float dealer_cost(void);

float lowest_price(void)
  {
    return (1 + MARKUP) * dealer_cost();
  }

static float dealer_cost(void)
  {
    float base_cost, options_cost;

    base_cost = (imported) ?
        (1 + SURCHARGE) * WHOLESALE_FACTOR * base_price :
        WHOLESALE_FACTOR * base_price;
    options_cost = WHOLESALE_FACTOR * options;
    return base_cost + options_cost;
  }
