#include <stdio.h>
#define  MAXROWS  10
#define  MAXCOLS  10

void readm(float matrix[][MAXCOLS],
           int rows, int cols);
void writem(float matrix[][MAXCOLS],
            int rows, int cols);
void multiply(float matrix1[][MAXCOLS],
              int rows1, int cols1,
              float matrix2[][MAXCOLS], int cols2,
              float product[][MAXCOLS]);

main()
  {
    float  matrix1[MAXROWS][MAXCOLS],
           matrix2[MAXROWS][MAXCOLS],
           product[MAXROWS][MAXCOLS];
    int    rows1, cols1, rows2, cols2;

    /* get the actual dimensions of the matrices */

    do
      {
        printf("dimensions of matrix1?\n");
        scanf("%d %d", &rows1, &cols1);
        printf("dimensions of matrix2?\n");
        scanf("%d %d", &rows2, &cols2);

        if (cols1 != rows2)
            printf("columns in matrix1 must "
                   "equal rows in matrix2\n");
        else if (rows1 > MAXROWS || cols1 > MAXCOLS)
            printf("matrix1 is too big\n");
        else if (rows2 > MAXROWS || cols2 > MAXCOLS)
            printf("matrix2 is too big\n");
        else
            break;
      }
    while(1);

    /* read the matrices */

    printf("enter row-wise "
           "the elements of matrix1\n");
    readm(matrix1, rows1, cols1);

    printf("enter row-wise "
           "the elements of matrix2\n");
    readm(matrix2, rows2, cols2);

    /* compute the product matrix */

    multiply(matrix1, rows1, cols1,
             matrix2, cols2, product);

    /* print results */

    printf("product matrix:\n");
    writem(product, rows1, cols2);

    return 0;

  }

void readm(float matrix[][MAXCOLS],
           int rows, int cols)
  {
    int i, j;

    for (i = 0; i < rows; i++)
        for (j = 0; j < cols; j++)
            scanf("%f", &matrix[i][j]);
  }

void multiply(float matrix1[][MAXCOLS],
              int rows1, int cols1,
              float matrix2[][MAXCOLS], int cols2,
              float product[][MAXCOLS])
  {
    int i, j, k;

    for (i = 0; i < rows1; i++)
        for (j = 0; j < cols2; j++)
          {
            product[i][j] = 0;
            for (k = 0; k < cols1; k++)
                product[i][j] +=
                    matrix1[i][k] * matrix2[k][j];
          }
  }

void writem(float matrix[][MAXCOLS],
            int rows, int cols)
  {
    int i, j;

    for (i = 0; i < rows; i++)
      {
        for (j = 0; j < cols; j++)
            printf("%f ", matrix[i][j]);
        printf("\n");;
      }
  }
