/*
 *  all contains in one
 */

#include <stdio.h>

struct point
  {
    float x, y;
  };

struct circle
  {
    float r;          /* radius */
    struct point o;   /* center */
  };

struct circle c = {2, {1, 1}};
struct point  p = {2, 2};

float sqr(float x)
  {
    return x * x;
  }

int contains1(float cr, float cx, float cy, float px, float py)
  {
    return sqr(cx - px) + sqr(cy - py) > sqr(cr) ? 0 : 1;
  }

int contains2(struct circle c, struct point p)
  {
    return sqr(c.o.x - p.x) + sqr(c.o.y - p.y) > sqr(c.r) ? 0 : 1;
  }

int contains3(struct circle *c, struct point *p)
  {
    return sqr(c->o.x - p->x)+sqr(c->o.y - p->y) > sqr(c->r) ? 0 : 1;
  }

int main(void)
  {
    if (contains1(c.r, c.o.x, c.o.y, p.x, p.y) &&
        contains2(c, p) && contains3(&c, &p))
	       printf("true\n");
  }
