#include <math.h>
#include <stdio.h>

struct polar
  {
    float r, theta;
  };

struct rectangular
  {
    float x, y;
  };

struct polar convert(struct rectangular rec)
  {
    struct polar pol;

    if (rec.x == 0 && rec.y == 0)  /* origin */
        pol.r = pol.theta = 0;
    else
      {
        pol.r = sqrt(rec.x * rec.x + rec.y * rec.y);
        pol.theta = atan2(rec.y, rec.x);
      }

    return pol;
  }

int main(void)
  {
    struct rectangular r = {2, 1};
    struct polar p;

    p = convert(r);
    printf("%f %f\n", p.r, p.theta);

    return 0;
  }
