#include <stdio.h>
#define  BASE   1900

char *monthname[] =
  {
    "Jan", "Feb", "Mar", "Apr", "May", "Jun",
    "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
  };

char *dayname[] =
  {
    "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"
  };

struct dt
  {
    unsigned day      : 5;  /* 1 - 31 */
    unsigned month    : 4;  /* 0 - 11 (0 => january) */
    unsigned year     : 8;  /* 1900 - 2099 */
    unsigned weekday  : 3;  /* 0 - 6 (0 => monday) */
    unsigned hour     : 4;  /* 1 - 12 */
    unsigned minute   : 6;  /* 0 - 59 */
    unsigned am       : 1;  /* 1 => a.m.  0 => p.m. */
  } now = {1, 0, 0, 0, 12, 0, 1};

void date(struct dt t)
  {
    printf("%s %s %d %d:%d %s %d\n", dayname[t.weekday],
	   monthname[t.month], t.day, t.hour, t.minute,
	   t.am ? "AM" : "PM", t.year+BASE);
  };
