#include <stdarg.h>

double min(double oldmin, int nterms, ... )
  {
    va_list ap;
    double val;
    int i;

    va_start(ap, nterms);
    for(i = 0; i < nterms; i++)
        if ((val = va_arg(ap, double)) < oldmin)
            oldmin = val;
    va_end(ap);
    return oldmin;
  }
