#include <stdio.h>
#define  START       10
#define  END         99

int main(void)
  {
    int n, p, number, maxp;

    /* computes the persistence number of n */
    int p_number(int n);

    for(n = START, maxp = 0; n <= END; n++)
      {
        p = p_number(n);

        if (p > maxp) /*  save values */
          {
            maxp = p;
            number = n;
          }
      }

    printf("number = %d  persistence = %d\n",
            number, maxp);
    return 0;
  }


int p_number(int n)
  {
    int p;

    /* computes the product of the digits of n */
    int digitprod(int n);

    /* loop while the digit product does not become a single-digit number */
    for(p = 0; n/10 != 0; p++)
        n = digitprod(n);

    return p;
  }


int digitprod(int n)
  {
    int digit, prod;

    prod = 1;

    do
      {
        digit = n % 10; /* the rightmost digit */
        prod *= digit;
        n /= 10; /* number after deleting the rightmost digit */
      }
    while (n != 0);

    return prod;
  }
