/*
 * Function to convert the string representation of a number
 * into its integer value
 */

#define  isspace(c)  (c) == ' ' || (c) == '\t' ? 1 : 0
#define  issign(c)   (c) == '-' || (c) == '+' ? 1 : 0
#define  isdigit(c)  (c) >= '0' && (c) <= '9' ? 1 : 0

int atoi(char *s)
  {
    int n, sign;

    for ( ; isspace(*s); s++); /* skip white space */

    sign = *s == '-' ? -1 : 1;
    if (issign(*s)) s++;       /* skip sign */

    for (n = 0; isdigit(*s); s++)
        n = 10 * n + (*s - '0');

    return sign * n;
  }
