#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define  WRITE(R,T)  printf("%f %f\n", R, T)

struct polar
  {
    float r, theta;
  };

struct rectangular
  {
    float x, y;
  };

struct polar *convert(struct rectangular rec)
  {
    struct polar *polp;

    polp = (struct polar *)malloc(sizeof(struct polar));
    if (polp)
      {
        if (rec.x == 0 && rec.y == 0)
            polp->r = polp->theta = 0;
        else
          {
            polp->r = sqrt(rec.x*rec.x + rec.y*rec.y);
            polp->theta = atan2(rec.y, rec.x);
          }
      }
    return polp;
  }

int main(void)
  {
    struct rectangular r = {2, 1};
    struct polar *pp;

    if (pp = convert(r))
        printf("%f %f\n", pp->r, pp->theta);

    return 0;
  }
