/*******************   main.c   ******************/

#include "global.h"

int triplet(struct complex z1,
            struct complex z2, struct complex z3)
  {
    return
      equal(add(multiply(z1,z1), multiply(z2,z2)),
            multiply(z3,z3));
  }

int main(void)
  {
    struct complex z1, z2, z3;
    int p;

    readc(&z1);
    readc(&z2);
    readc(&z3);

    p = triplet(z1,z2,z3) ||
        triplet(z2,z3,z1) || triplet(z3,z1,z2);

    printf("%s\n", p ? "yes" : "no");
    return 0;
  }
