#include <stdio.h>
#define  DUMMY  '\xff'

void compress(void)
  {
    int c, i;
    unsigned char first, rest;

    while ((c = getchar()) != EOF)
      {
        first = (unsigned char) c;

        first <<= 1;  /* shift out the unused 8th bit */

        for (i = 0; i < 7; i++)
          {
            if ((c = getchar()) != EOF)
                /* turn off the 8th bit */
                rest = (unsigned char) c & '\x7f';
            else
                rest = DUMMY;

            /* piggyback one bit of first */
            rest |= (first << i) & '\x80';

            putchar(rest);
          }
      }
  }
#include <stdio.h>
#define  DUMMY  '\xff'

void decompress(void)
  {
    int c, i;
    unsigned char byte[8];

    for (;;)
      {
        for (i = 1, byte[0] = 0; i < 8; i++)
          {
            if ((c = getchar()) == EOF) return;
            /* turn off the 8th bit */
            byte[i] = (unsigned char) c & '\x7f';
            /* assemble the first character */
            byte[0] |= ((unsigned char) c & '\x80') >> i;
          }
        for (i = 0; i < 8; i++) /* output 8 characters */
            if (byte[i] != DUMMY) putchar(byte[i]);
      }
  }
